;----------------- tb51 ver. 3 ------------
$MODID51
$IC(MACROS51)
	SELECT	NONE

;--------------------------------------------
PRINTCHAR       MACRO	CH
	SETCTRL		0
	CLRCTRL		1
	SETB		E_LCD
	MOV		DAT, CH
	CLR		E_LCD	
ENDM
;--------------------------------------------

	COMMAND	#01H
	COMMAND	#80H
	COMMAND	#0FH

NOT_PRESSED:

	MCALL           HNM_IFKBHIT
	JNC		NOT_PRESSED

	MCALL           HNM_GETSCAN

	MOV		DPTR, #KeyTable
	MOVMEM		A, @A+DPTR
	DISPCH		A

        MOV             R2, #0FFH
INNER:	MOV             R1, #0FFH
AGAIN:	DJNZ            R1, AGAIN
	DJNZ            R2, INNER

	MJMP		NOT_PRESSED

;-----------------------------
HNM_IFKBHIT:

	MOV		DAT, #0FH
	SELECT		KEY

	JNB		DAT.0 , RET_PRESSED
	JNB		DAT.1 , RET_PRESSED
	JNB		DAT.2 , RET_PRESSED
	JNB		DAT.3 , RET_PRESSED
	
	CLR		C		
	RET
RET_PRESSED:
	SETB		C	
	RET

;-----------------------------
HNM_GETSCAN:
	MOV		DAT, #0FH
	SELECT		KEY
	
	JB		DAT.0, COLUMN2

	SETB		DAT.4
	JNB		DAT.0, COLUMN1_4
	MOV		A, #0
	RET

COLUMN1_4:
	SETB		DAT.5
	JNB		DAT.0, COLUMN1_7
	MOV		A, #4
	RET

COLUMN1_7:
	SETB		DAT.6
	JNB		DAT.0, COLUMN1_S
	MOV		A, #8
	RET

COLUMN1_S:
	MOV		A, #12
	RET

COLUMN2:
	JB		DAT.1, COLUMN3

	SETB		DAT.4
	JNB		DAT.1, COLUMN2_5
	MOV		A, #1
	RET

COLUMN2_5:
	SETB		DAT.5
	JNB		DAT.1, COLUMN2_8
	MOV		A, #5
	RET

COLUMN2_8:
	SETB		DAT.6
	JNB		DAT.1, COLUMN2_0
	MOV		A, #9
	RET

COLUMN2_0:
	MOV		A, #13
	RET

COLUMN3:
	JB		DAT.2, COLUMN4

	SETB		DAT.4
	JNB		DAT.2, COLUMN3_6
	MOV		A, #2
	RET

COLUMN3_6:
	SETB		DAT.5
	JNB		DAT.2, COLUMN3_9
	MOV		A, #6
	RET

COLUMN3_9:
	SETB		DAT.6
	JNB		DAT.2, COLUMN3_M
	MOV		A, #10
	RET

COLUMN3_M:
	MOV		A, #14
	RET

COLUMN4:

	SETB		DAT.4
	JNB		DAT.3, COLUMN4_U
	MOV		A, #3
	RET

COLUMN4_U:
	SETB		DAT.5
	JNB		DAT.3, COLUMN4_D
	MOV		A, #7
	RET

COLUMN4_D:
	SETB		DAT.6
	JNB		DAT.3, COLUMN4_E
	MOV		A, #11
	RET

COLUMN4_E:
	MOV		A, #15
	RET

;----------------------------
KeyTable:	DB	'123P456U789DS0ME', 0


;---------------------
END
